package ITL_eSSP;

/**
 *
 * @author Admin
 */
import java.security.SecureRandom;
import java.math.*;
import java.util.*;

public class RandomNumber {

    SecureRandom rand = new SecureRandom();

    public long GenerateRandomNumber() {
        long rnd = 0;
        byte i;
        byte[] tmp = new byte[8];

        rand.nextBytes(tmp);

        for (i = 0; i < 8; i++) {
            if (i == 7) {
                rnd += (long) (tmp[i] & 0x7F) << (8 * i);
            } else {
                rnd += (long) tmp[i] << (8 * i);
            }
        }

        return rnd;
    }

    public long GeneratePrime() {
        return BigInteger.probablePrime(31, new Random()).longValue();
    }

    public long XpowYmodN(long x, long y, long N) {
        BigInteger bix = BigInteger.valueOf(x);
        BigInteger biy = BigInteger.valueOf(y);
        BigInteger biN = BigInteger.valueOf(N);

        BigInteger bires;
        bires = bix.modPow(biy, biN);

        return bires.longValue();
    }
}
